/* GTK Napster-0.201
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "common.h"
#include "menu.h"

GtkWidget *make_menu(gtk_sess *sess)
{
	GtkWidget *menu_bar;

	GtkWidget *file_menu;
	GtkWidget *item_connect;
	GtkWidget *item_disconnect;
	GtkWidget *item_quit;
	GtkWidget *file_item;
	
	GtkWidget *view_menu;
	GtkWidget *search_item;
	GtkWidget *chat_item;
	GtkWidget *hl_item;
	GtkWidget *transfer_item;
	GtkWidget *view_item;
	
	GtkWidget *edit_menu;
	GtkWidget *settings_item;
	GtkWidget *edit_item;
	
	GtkWidget *hotlist_menu;
	GtkWidget *addhl_item;
	GtkWidget *remove_item;
	GtkWidget *refresh_item;
	GtkWidget *hotlist_item;
	
	GtkWidget *about_item;
	
	file_menu = gtk_menu_new();
	
	item_quit = gtk_menu_item_new_with_label(MENU_ITEM_QUIT);	
	item_connect = gtk_menu_item_new_with_label(MENU_ITEM_CONNECT);
	item_disconnect = gtk_menu_item_new_with_label(MENU_ITEM_DISCONNECT);
	gtk_menu_append(GTK_MENU(file_menu), item_connect);
	gtk_menu_append(GTK_MENU(file_menu), item_disconnect);
	gtk_menu_append(GTK_MENU(file_menu), item_quit);
	
	gtk_signal_connect(GTK_OBJECT(item_connect), "activate", GTK_SIGNAL_FUNC(connect_dialog), sess);
	gtk_signal_connect(GTK_OBJECT(item_disconnect), "activate", GTK_SIGNAL_FUNC(disconnect_napster), sess);
	gtk_signal_connect(GTK_OBJECT(item_quit), "activate", GTK_SIGNAL_FUNC(destroy), sess);
	
	gtk_widget_show(item_connect);
	gtk_widget_show(item_disconnect);
	gtk_widget_show(item_quit);
	
	view_menu = gtk_menu_new();
	
	chat_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOCHAT);	
	search_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOSEARCH);
	hl_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOHOTLIST);
	transfer_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOTRANSFER);
	gtk_menu_append(GTK_MENU(view_menu), chat_item);
	gtk_menu_append(GTK_MENU(view_menu), search_item);
	gtk_menu_append(GTK_MENU(view_menu), hl_item);
	gtk_menu_append(GTK_MENU(view_menu), transfer_item);

	gtk_signal_connect(GTK_OBJECT(search_item), "activate", GTK_SIGNAL_FUNC(change_to_search), sess);
	gtk_signal_connect(GTK_OBJECT(transfer_item), "activate", GTK_SIGNAL_FUNC(change_to_transfer), sess);
	gtk_signal_connect(GTK_OBJECT(chat_item), "activate", GTK_SIGNAL_FUNC(change_to_chat), sess);
	gtk_signal_connect(GTK_OBJECT(hl_item), "activate", GTK_SIGNAL_FUNC(change_to_hotlist), sess);
	
	gtk_widget_show(search_item);
	gtk_widget_show(transfer_item);
	gtk_widget_show(hl_item);
	gtk_widget_show(chat_item);
	
	edit_menu = gtk_menu_new();
	settings_item = gtk_menu_item_new_with_label(MENU_ITEM_SETTINGS);	
	gtk_menu_append(GTK_MENU(edit_menu), settings_item);
	gtk_signal_connect(GTK_OBJECT(settings_item), "activate", GTK_SIGNAL_FUNC(settings_dialog), sess);
	gtk_widget_show(settings_item);
	
	hotlist_menu = gtk_menu_new();
	addhl_item = gtk_menu_item_new_with_label(MENU_ITEM_ADDHL);	
	gtk_menu_append(GTK_MENU(hotlist_menu), addhl_item);
	gtk_signal_connect(GTK_OBJECT(addhl_item), "activate", GTK_SIGNAL_FUNC(add_hl_dialog), sess);
	gtk_widget_show(addhl_item);
	
	remove_item = gtk_menu_item_new_with_label(MENU_ITEM_REMOVEHL);	
	gtk_menu_append(GTK_MENU(hotlist_menu), remove_item);
	gtk_signal_connect(GTK_OBJECT(remove_item), "activate", GTK_SIGNAL_FUNC(remove_hl_dialog), sess);
	gtk_widget_show(remove_item);
	
	refresh_item = gtk_menu_item_new_with_label(MENU_ITEM_REFRESH);	
	gtk_menu_append(GTK_MENU(hotlist_menu), refresh_item);
	gtk_signal_connect(GTK_OBJECT(refresh_item), "activate", GTK_SIGNAL_FUNC(hl_send_logon_request), sess);
	gtk_widget_show(refresh_item);
	
	file_item = gtk_menu_item_new_with_label(MENU_FILE);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_item), file_menu);
	gtk_widget_show(file_item);
	
	edit_item = gtk_menu_item_new_with_label(MENU_EDIT);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(edit_item), edit_menu);
	gtk_widget_show(edit_item);
	
	view_item = gtk_menu_item_new_with_label(MENU_VIEW);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(view_item), view_menu);
	gtk_widget_show(view_item);
	
	hotlist_item = gtk_menu_item_new_with_label(MENU_HOTLIST);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(hotlist_item), hotlist_menu);
	gtk_widget_show(hotlist_item);
	
	about_item = gtk_menu_item_new_with_label(MENU_ABOUT);
	gtk_signal_connect(GTK_OBJECT(about_item), "activate", GTK_SIGNAL_FUNC(about_napster), sess);
	gtk_widget_show(about_item);
	
	menu_bar = gtk_menu_bar_new();
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), file_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), edit_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), view_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), hotlist_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), about_item);
	gtk_menu_item_right_justify(GTK_MENU_ITEM(about_item));
	
	return menu_bar;
}
